searchData={"items":[{"type":"module","title":"Signet","doc":"Signet is a library for interacting with private keys, signatures, and Etheruem.","ref":"Signet.html"},{"type":"function","title":"Signet.get_contract_address/1","doc":"Returns a contract address, that may have been set in configuration.","ref":"Signet.html#get_contract_address/1"},{"type":"function","title":"Examples - Signet.get_contract_address/1","doc":"iex> Signet.get_contract_address(<<1::160>>)\n    <<1::160>>\n\n    iex> Signet.get_contract_address(\"0x0000000000000000000000000000000000000001\")\n    <<1::160>>\n\n    iex> Application.put_env(:signet, :contracts, [test: \"0x0000000000000000000000000000000000000001\"])\n    iex> Signet.get_contract_address(:test)\n    <<1::160>>\n\n    iex> Application.put_env(:signet, :contracts, [test: \"0x0000000000000000000000000000000000000001\"])\n    iex> Signet.get_contract_address(:test_00)\n    ** (KeyError) key :test_00 not found in: [test: \"0x0000000000000000000000000000000000000001\"]","ref":"Signet.html#get_contract_address/1-examples"},{"type":"type","title":"Signet.address/0","doc":"","ref":"Signet.html#t:address/0"},{"type":"type","title":"Signet.bytes32/0","doc":"","ref":"Signet.html#t:bytes32/0"},{"type":"type","title":"Signet.contract/0","doc":"","ref":"Signet.html#t:contract/0"},{"type":"type","title":"Signet.signature/0","doc":"","ref":"Signet.html#t:signature/0"},{"type":"module","title":"Signet.Erc20","doc":"A wrapper for an [ERC-20 contract](https://eips.ethereum.org/EIPS/eip-20),\nallowing the code to interact by pulling data from the contract, or sending\ntransaction to it.","ref":"Signet.Erc20.html"},{"type":"function","title":"Signet.Erc20.call_trx/3","doc":"","ref":"Signet.Erc20.html#call_trx/3"},{"type":"function","title":"Signet.Erc20.errors/0","doc":"Returns a list of known error codes (ABI signatures), which can be used\nwhen parsing error messages from contract calls.","ref":"Signet.Erc20.html#errors/0"},{"type":"function","title":"Signet.Erc20.exec_trx/3","doc":"","ref":"Signet.Erc20.html#exec_trx/3"},{"type":"function","title":"Signet.Erc20.transfer/4","doc":"Executes a `transfer` transaction.\n\nArguments:\n  - `destination`: The destination address\n  - `amount_wei`: The amount, in token wei, to transfer.\n  - `exec_opts`: Execution options, such as the gas price for the transaction.","ref":"Signet.Erc20.html#transfer/4"},{"type":"function","title":"Examples - Signet.Erc20.transfer/4","doc":"iex> {:ok, _trx_id} = Signet.Erc20.transfer(<<0xCC>>, <<0xDD>>, 100_000)","ref":"Signet.Erc20.html#transfer/4-examples"},{"type":"type","title":"Signet.Erc20.call_opts/0","doc":"","ref":"Signet.Erc20.html#t:call_opts/0"},{"type":"type","title":"Signet.Erc20.exec_opts/0","doc":"","ref":"Signet.Erc20.html#t:exec_opts/0"},{"type":"module","title":"Signet.Erc20.Call","doc":"Module to call operations and receive return value, without sending a transaction.","ref":"Signet.Erc20.Call.html"},{"type":"function","title":"Signet.Erc20.Call.balance_of/3","doc":"Calls the `balanceOf` operation, returning the result of the Ethereum function call.","ref":"Signet.Erc20.Call.html#balance_of/3"},{"type":"function","title":"Examples - Signet.Erc20.Call.balance_of/3","doc":"iex> Signet.Erc20.Call.balance_of(<<0xCC>>, <<0xDD>>)\n    {:ok, <<>>}","ref":"Signet.Erc20.Call.html#balance_of/3-examples"},{"type":"function","title":"Signet.Erc20.Call.transfer/4","doc":"Calls the `transfer` operation, returning the result of the Ethereum function call.","ref":"Signet.Erc20.Call.html#transfer/4"},{"type":"function","title":"Examples - Signet.Erc20.Call.transfer/4","doc":"iex> Signet.Erc20.Call.transfer(<<0xCC>>, <<0xDD>>, 100_000)\n    {:ok, <<>>}","ref":"Signet.Erc20.Call.html#transfer/4-examples"},{"type":"module","title":"Signet.Erc20.CallData","doc":"Module to encode `calldata` for given adaptor operations.","ref":"Signet.Erc20.CallData.html"},{"type":"function","title":"Signet.Erc20.CallData.balance_of/1","doc":"Encodes the call data for a `balanceOf` operation.","ref":"Signet.Erc20.CallData.html#balance_of/1"},{"type":"function","title":"Examples - Signet.Erc20.CallData.balance_of/1","doc":"iex> Signet.Erc20.CallData.balance_of(<<0xDD>>) |> Signet.Util.encode_hex()\n    \"0x\"","ref":"Signet.Erc20.CallData.html#balance_of/1-examples"},{"type":"function","title":"Signet.Erc20.CallData.transfer/2","doc":"Encodes the call data for a `transfer` operation.","ref":"Signet.Erc20.CallData.html#transfer/2"},{"type":"function","title":"Examples - Signet.Erc20.CallData.transfer/2","doc":"iex> Signet.Erc20.CallData.transfer(<<0xDD>>, 100_000)\n    ...> |> Signet.Util.encode_hex()\n    \"0x8035F0CE\"","ref":"Signet.Erc20.CallData.html#transfer/2-examples"},{"type":"module","title":"Signet.Filter","doc":"A system to create an Ethereum log filter and have\nparsed events passed back to registered processes.","ref":"Signet.Filter.html"},{"type":"function","title":"Signet.Filter.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Signet.Filter.html#child_spec/1"},{"type":"function","title":"Signet.Filter.init/1","doc":"","ref":"Signet.Filter.html#init/1"},{"type":"function","title":"Signet.Filter.listen/1","doc":"","ref":"Signet.Filter.html#listen/1"},{"type":"function","title":"Signet.Filter.start_link/1","doc":"","ref":"Signet.Filter.html#start_link/1"},{"type":"module","title":"Signet.Filter.Log","doc":"","ref":"Signet.Filter.Log.html"},{"type":"function","title":"Signet.Filter.Log.deserialize/1","doc":"","ref":"Signet.Filter.Log.html#deserialize/1"},{"type":"module","title":"Signet.Hash","doc":"","ref":"Signet.Hash.html"},{"type":"function","title":"Signet.Hash.keccak/1","doc":"Returns the keccak of the given binary message.","ref":"Signet.Hash.html#keccak/1"},{"type":"function","title":"Examples - Signet.Hash.keccak/1","doc":"iex> Signet.Hash.keccak(\"test\")\n  <<156, 34, 255, 95, 33, 240, 184, 27, 17, 62, 99, 247, 219, 109, 169, 79, 237, 239, 17, 178, 17, 155, 64, 136, 184, 150, 100, 251, 154, 60, 182, 88>>","ref":"Signet.Hash.html#keccak/1-examples"},{"type":"function","title":"Signet.Hash.keccak_unsigned/1","doc":"Returns the keccak of the given binary message, as an unsigned.","ref":"Signet.Hash.html#keccak_unsigned/1"},{"type":"function","title":"Examples - Signet.Hash.keccak_unsigned/1","doc":"iex> Signet.Hash.keccak_unsigned(\"test\")\n  70622639689279718371527342103894932928233838121221666359043189029713682937432","ref":"Signet.Hash.html#keccak_unsigned/1-examples"},{"type":"module","title":"Signet.Keys","doc":"Signet library to generate Ethereum key pairs.","ref":"Signet.Keys.html"},{"type":"function","title":"Signet.Keys.generate_keypair/0","doc":"Generates a new keypair as an `{eth_address, private_key}`.","ref":"Signet.Keys.html#generate_keypair/0"},{"type":"function","title":"Examples - Signet.Keys.generate_keypair/0","doc":"iex> {address, priv_key} = Signet.Keys.generate_keypair()\n    iex> {byte_size(address), byte_size(priv_key)}\n    {20, 32}","ref":"Signet.Keys.html#generate_keypair/0-examples"},{"type":"module","title":"Signet.RPC","doc":"Excessively simple RPC client for Ethereum.","ref":"Signet.RPC.html"},{"type":"function","title":"Signet.RPC.call_trx/2","doc":"RPC call to call a transaction and preview results.","ref":"Signet.RPC.html#call_trx/2"},{"type":"function","title":"Examples - Signet.RPC.call_trx/2","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.call_trx()\n    {:ok, <<0x0c>>}\n\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.call_trx(decode: :hex_unsigned)\n    {:ok, 0x0c}\n\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<10::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.call_trx()\n    {:error, \"error 3: execution reverted (0x3d738b2e)\"}\n\n    iex> errors = [\"Unauthorized()\", \"BadNonce()\", \"NotEnoughSigners()\", \"NotActiveWithdrawalAddress()\", \"NotActiveOperator()\", \"DuplicateSigners()\"]\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<10::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.call_trx(errors: errors)\n    {:error, \"error 3: execution reverted (NotActiveOperator()[])\"}\n\n    iex> errors = [\"Cool(uint256,string)\"]\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<11::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.call_trx(errors: errors)\n    {:error, \"error 3: execution reverted (Cool(uint256,string)[1, \\\"cat\\\"])\"}","ref":"Signet.RPC.html#call_trx/2-examples"},{"type":"function","title":"Signet.RPC.estimate_gas/2","doc":"RPC call to call to estimate gas used by a given call.","ref":"Signet.RPC.html#estimate_gas/2"},{"type":"function","title":"Examples - Signet.RPC.estimate_gas/2","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>)\n    iex> |> Signet.RPC.estimate_gas()\n    {:ok, 0x0d}","ref":"Signet.RPC.html#estimate_gas/2-examples"},{"type":"function","title":"Signet.RPC.execute_trx/3","doc":"Helper function to work with other Signet modules to get a nonce, sign a transction, and transmit it to the network.\n\nIf you need higher-level functionality, like manual nonce tracking, you may want to use the more granular function calls.\n\nOptions:\n  * `gas_price` - Set the base gas for the transaction, overrides all other gas prices listed below (default `nil`)\n  * `base_fee` - Set the base price for the transaction, if nil, will use base gas price from `eth_gasPrice` call (default `nil`)\n  * `base_fee_buffer` - Buffer for the gas price when estimating gas (default: 1.2 = 120%)\n  * `priority_fee` - Additional gas to send as a priority fee. (default: `{0, :gwei}`)\n  * `gas_limit` - Set the gas limit for the transaction (default: calls `eth_estimateGas`)\n  * `gas_buffer` - Buffer if estimating gas limit (default: 1.5 = 150%)\n  * `value` - Value to provide with transaction in wei (default: 0)\n  * `nonce` - Nonce to send with transaction. (default: lookup via `eth_transactionCount`)\n  * `verify` - Verify the function is likely to succeed before submitting (default: true)\n\n  Note: if we don't `verify`, then `estimateGas` will likely fail if the transaction were to fail.\n        To prevent this, `gas_limit` should always be supplied when `verify` is set to false.\n\n  Note: Currently Signet uses pre-EIP-1559 signatures and thus gas prices are not broken out by\n        base fee and priority fee.","ref":"Signet.RPC.html#execute_trx/3"},{"type":"function","title":"Examples - Signet.RPC.execute_trx/3","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<1::160>>, {\"baz(uint,address)\", [50, :binary.decode_unsigned(<<1::160>>)]}, gas_price: {50, :gwei}, value: 0, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {4, 50000000000, 20, <<1::160>>}\n\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<1::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, gas_price: {50, :gwei}, gas_limit: 100_000, value: 0, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {4, 50000000000, 100000, <<1::160>>}\n\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<1::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, gas_price: {50, :gwei}, gas_limit: 100_000, value: 0, nonce: 10, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {10, 50000000000, 100000, <<1::160>>}\n\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> Signet.RPC.execute_trx(<<10::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, gas_price: {50, :gwei}, gas_limit: 100_000, value: 0, nonce: 10, signer: signer_proc)\n    {:error, \"error 3: execution reverted (0x3d738b2e)\"}\n\n    iex> # Set gas price directly\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<10::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, gas_price: {50, :gwei}, gas_limit: 100_000, value: 0, nonce: 10, verify: false, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {10, 50000000000, 100000, <<10::160>>}\n\n    iex> # Default gas price\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<10::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, gas_limit: 100_000, value: 0, nonce: 10, verify: false, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {10, 1200000000, 100000, <<10::160>>}\n\n    iex> # Set priority fee\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<10::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, priority_fee: {3, :gwei}, gas_limit: 100_000, value: 0, nonce: 10, verify: false, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {10, 4200000000, 100000, <<10::160>>}\n\n    iex> # Set base fee and priority fee\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, trx_id} = Signet.RPC.execute_trx(<<10::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, base_fee: {1, :gwei}, priority_fee: {3, :gwei}, gas_limit: 100_000, value: 0, nonce: 10, verify: false, signer: signer_proc)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {10, 4000000000, 100000, <<10::160>>}","ref":"Signet.RPC.html#execute_trx/3-examples"},{"type":"function","title":"Signet.RPC.gas_price/1","doc":"RPC call to call to get the current gas price.","ref":"Signet.RPC.html#gas_price/1"},{"type":"function","title":"Examples - Signet.RPC.gas_price/1","doc":"iex> Signet.RPC.gas_price()\n    {:ok, 1000000000}","ref":"Signet.RPC.html#gas_price/1-examples"},{"type":"function","title":"Signet.RPC.get_nonce/2","doc":"RPC call to get account nonce.","ref":"Signet.RPC.html#get_nonce/2"},{"type":"function","title":"Examples - Signet.RPC.get_nonce/2","doc":"iex> Signet.RPC.get_nonce(Signet.Util.decode_hex!(\"0x407d73d8a49eeb85d32cf465507dd71d507100c1\"))\n    {:ok, 4}","ref":"Signet.RPC.html#get_nonce/2-examples"},{"type":"function","title":"Signet.RPC.get_trx_receipt/2","doc":"RPC call to get a transaction receipt","ref":"Signet.RPC.html#get_trx_receipt/2"},{"type":"function","title":"Examples - Signet.RPC.get_trx_receipt/2","doc":"iex> Signet.RPC.get_trx_receipt(<<0::256>>)\n    {:ok,\n      %Signet.Receipt{\n        transaction_hash: Signet.Util.decode_hex!(\"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\"),\n        transaction_index: 0x66,\n        block_hash: Signet.Util.decode_hex!(\"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\"),\n        block_number: 0xeff35f,\n        from: Signet.Util.decode_hex!(\"0x6221a9c005f6e47eb398fd867784cacfdcfff4e7\"),\n        to: Signet.Util.decode_hex!(\"0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2\"),\n        cumulative_gas_used: 0xa12515,\n        effective_gas_price: 0x5a9c688d4,\n        gas_used: 0xb4c8,\n        contract_address: nil,\n        logs: [\n          %Signet.Receipt.Log{\n            log_index: 1,\n            block_number: 0x01b4,\n            block_hash: Signet.Util.decode_hex!(\"0xaa8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n            transaction_hash: Signet.Util.decode_hex!(\"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\"),\n            transaction_index: 0,\n            address: Signet.Util.decode_hex!(\"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n            data: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000000\"),\n            topics: [\n              Signet.Util.decode_hex!(\"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\")\n            ]\n          }\n        ],\n        logs_bloom: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000001\"),\n        type: 0x02,\n        status: 0x01,\n      }\n    }\n\n    iex> Signet.RPC.get_trx_receipt(\"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\")\n    {:ok,\n      %Signet.Receipt{\n        transaction_hash: Signet.Util.decode_hex!(\"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\"),\n        transaction_index: 0x66,\n        block_hash: Signet.Util.decode_hex!(\"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\"),\n        block_number: 0xeff35f,\n        from: Signet.Util.decode_hex!(\"0x6221a9c005f6e47eb398fd867784cacfdcfff4e7\"),\n        to: Signet.Util.decode_hex!(\"0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2\"),\n        cumulative_gas_used: 0xa12515,\n        effective_gas_price: 0x5a9c688d4,\n        gas_used: 0xb4c8,\n        contract_address: nil,\n        logs: [\n          %Signet.Receipt.Log{\n            log_index: 1,\n            block_number: 0x01b4,\n            block_hash: Signet.Util.decode_hex!(\"0xaa8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n            transaction_hash: Signet.Util.decode_hex!(\"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\"),\n            transaction_index: 0,\n            address: Signet.Util.decode_hex!(\"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n            data: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000000\"),\n            topics: [\n              Signet.Util.decode_hex!(\"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\")\n            ]\n          }\n        ],\n        logs_bloom: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000001\"),\n        type: 0x02,\n        status: 0x01,\n      }\n    }\n\n    iex> Signet.RPC.get_trx_receipt(<<1::256>>)\n    {:error, \"failed to decode result\"}","ref":"Signet.RPC.html#get_trx_receipt/2-examples"},{"type":"function","title":"Signet.RPC.send_rpc/3","doc":"Simple RPC client for a JSON-RPC Ethereum node.","ref":"Signet.RPC.html#send_rpc/3"},{"type":"function","title":"Examples - Signet.RPC.send_rpc/3","doc":"iex> Signet.RPC.send_rpc(\"net_version\", [])\n    {:ok, \"3\"}\n\n    iex> Signet.RPC.send_rpc(\"get_balance\", [\"0x407d73d8a49eeb85d32cf465507dd71d507100c1\", \"latest\"], ethereum_node: \"http://example.com\")\n    {:ok, \"0x0234c8a3397aab58\"}","ref":"Signet.RPC.html#send_rpc/3-examples"},{"type":"function","title":"Signet.RPC.send_trx/2","doc":"RPC call to send a raw transaction.","ref":"Signet.RPC.html#send_trx/2"},{"type":"function","title":"Examples - Signet.RPC.send_trx/2","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, signed_trx} = Signet.Transaction.build_signed_trx(<<1::160>>, 5, {\"baz(uint,address)\", [50, :binary.decode_unsigned(<<1::160>>)]}, {50, :gwei}, 100_000, 0, chain_id: :goerli, signer: signer_proc)\n    iex> {:ok, trx_id} = Signet.RPC.send_trx(signed_trx)\n    iex> < > = trx_id\n    iex> {nonce, gas_price, gas_limit, to}\n    {5, 50000000000, 100000, <<1::160>>}","ref":"Signet.RPC.html#send_trx/2-examples"},{"type":"function","title":"Signet.RPC.trace_trx/2","doc":"RPC call to get a transaction receipt","ref":"Signet.RPC.html#trace_trx/2"},{"type":"function","title":"Examples - Signet.RPC.trace_trx/2","doc":"iex> Signet.RPC.trace_trx(\"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\")\n    {:ok,\n      [\n      %Signet.Trace{\n        action: %Signet.Trace.Action{\n          call_type: \"call\",\n          from: Signet.Util.decode_hex!(\"0x83806d539d4ea1c140489a06660319c9a303f874\"),\n          gas: 0x01a1f8,\n          input: <<>>,\n          to: Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"),\n          value: 0x7a16c911b4d00000,\n        },\n        block_hash: Signet.Util.decode_hex!(\"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\"),\n        block_number: 3068185,\n        gas_used: 0x2982,\n        output: <<>>,\n        subtraces: 2,\n        trace_address: [Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\")],\n        transaction_hash: Signet.Util.decode_hex!(\"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\"),\n        transaction_position: 2,\n        type: \"call\"\n      },\n      %Signet.Trace{\n        action: %Signet.Trace.Action{\n          call_type: \"call\",\n          from: Signet.Util.decode_hex!(\"0x83806d539d4ea1c140489a06660319c9a303f874\"),\n          gas: 0x01a1f8,\n          input: <<>>,\n          to: Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"),\n          value: 0x7a16c911b4d00000,\n        },\n        block_hash: Signet.Util.decode_hex!(\"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\"),\n        block_number: 3068186,\n        gas_used: 0x2982,\n        output: <<>>,\n        subtraces: 2,\n        trace_address: [Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\")],\n        transaction_hash: Signet.Util.decode_hex!(\"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\"),\n        transaction_position: 2,\n        type: \"call\"\n      }\n    ]}","ref":"Signet.RPC.html#trace_trx/2-examples"},{"type":"module","title":"Signet.Receipt","doc":"Represents an Ethereum transaction receipt, which contains information\nabout the success or failure of an Ethereum transaction after it has\nbeen included in a mined Ethereum block.\n\nSee `Signet.RPC.get_transaction_receipt` for getting receipts from\nan Ethereum JSON-RPC host.","ref":"Signet.Receipt.html"},{"type":"function","title":"Signet.Receipt.deserialize/1","doc":"Deserializes a transaction receipt as serialized by an Ethereum JSON-RPC response.\n\nSee also https://ethereum.org/en/developers/docs/apis/json-rpc#eth_gettransactionreceipt","ref":"Signet.Receipt.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Receipt.deserialize/1","doc":"iex> %{\n    ...>   \"blockHash\" => \"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\",\n    ...>   \"blockNumber\" => \"0xeff35f\",\n    ...>   \"contractAddress\" => nil,\n    ...>   \"cumulativeGasUsed\" => \"0xa12515\",\n    ...>   \"effectiveGasPrice\" => \"0x5a9c688d4\",\n    ...>   \"from\" => \"0x6221a9c005f6e47eb398fd867784cacfdcfff4e7\",\n    ...>   \"gasUsed\" => \"0xb4c8\",\n    ...>   \"logs\" => [%{\n    ...>     \"logIndex\" => \"0x1\",\n    ...>     \"blockNumber\" => \"0x1b4\",\n    ...>     \"blockHash\" => \"0xaa8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcfdf829c5a142f1fccd7d\",\n    ...>     \"transactionHash\" =>  \"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\",\n    ...>     \"transactionIndex\" => \"0x0\",\n    ...>     \"address\" => \"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\",\n    ...>     \"data\" => \"0x0000000000000000000000000000000000000000000000000000000000000000\",\n    ...>     \"topics\" => [\n    ...>       \"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\"\n    ...>     ]\n    ...>   }],\n    ...>   \"logsBloom\" => \"0x0000000000000000000000000000000000000000000000000000000000000001\",\n    ...>   \"status\" => \"0x1\",\n    ...>   \"to\" => \"0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2\",\n    ...>   \"transactionHash\" =>\n    ...>     \"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\",\n    ...>   \"transactionIndex\" => \"0x66\",\n    ...>   \"type\" => \"0x2\"\n    ...> }\n    ...> |> Signet.Receipt.deserialize()\n    %Signet.Receipt{\n      transaction_hash: Signet.Util.decode_hex!(\"0x85d995eba9763907fdf35cd2034144dd9d53ce32cbec21349d4b12823c6860c5\"),\n      transaction_index: 0x66,\n      block_hash: Signet.Util.decode_hex!(\"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\"),\n      block_number: 0xeff35f,\n      from: Signet.Util.decode_hex!(\"0x6221a9c005f6e47eb398fd867784cacfdcfff4e7\"),\n      to: Signet.Util.decode_hex!(\"0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2\"),\n      cumulative_gas_used: 0xa12515,\n      effective_gas_price: 0x5a9c688d4,\n      gas_used: 0xb4c8,\n      contract_address: nil,\n      logs: [\n        %Signet.Receipt.Log{\n          log_index: 1,\n          block_number: 0x01b4,\n          block_hash: Signet.Util.decode_hex!(\"0xaa8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n          transaction_hash: Signet.Util.decode_hex!(\"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\"),\n          transaction_index: 0,\n          address: Signet.Util.decode_hex!(\"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n          data: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000000\"),\n          topics: [\n            Signet.Util.decode_hex!(\"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\")\n          ]\n        }\n      ],\n      logs_bloom: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000001\"),\n      type: 0x02,\n      status: 0x01,\n    }","ref":"Signet.Receipt.html#deserialize/1-examples"},{"type":"type","title":"Signet.Receipt.t/0","doc":"","ref":"Signet.Receipt.html#t:t/0"},{"type":"module","title":"Signet.Receipt.Log","doc":"","ref":"Signet.Receipt.Log.html"},{"type":"function","title":"Signet.Receipt.Log.deserialize/1","doc":"Deserializes a transaction receipt as serialized by an Ethereum JSON-RPC response.\n\nSee also https://ethereum.org/en/developers/docs/apis/json-rpc#eth_gettransactionreceipt","ref":"Signet.Receipt.Log.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Receipt.Log.deserialize/1","doc":"iex> %{\n    ...>   \"logIndex\" => \"0x1\",\n    ...>   \"blockNumber\" => \"0x1b4\",\n    ...>   \"blockHash\" => \"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\",\n    ...>   \"transactionHash\" =>  \"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\",\n    ...>   \"transactionIndex\" => \"0x0\",\n    ...>   \"address\" => \"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\",\n    ...>   \"data\" => \"0x0000000000000000000000000000000000000000000000000000000000000000\",\n    ...>   \"topics\" => [\n    ...>     \"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\"\n    ...>   ]\n    ...> }\n    ...> |> Signet.Receipt.Log.deserialize()\n    %Signet.Receipt.Log{\n      log_index: 1,\n      block_number: 0x01b4,\n      block_hash: Signet.Util.decode_hex!(\"0xa957d47df264a31badc3ae823e10ac1d444b098d9b73d204c40426e57f47e8c3\"),\n      transaction_hash: Signet.Util.decode_hex!(\"0xaadf829c5a142f1fccd7d8216c5785ac562ff41e2dcfdf5785ac562ff41e2dcf\"),\n      transaction_index: 0,\n      address: Signet.Util.decode_hex!(\"0x16c5785ac562ff41e2dcfdf829c5a142f1fccd7d\"),\n      data: Signet.Util.decode_hex!(\"0x0000000000000000000000000000000000000000000000000000000000000000\"),\n      topics: [\n        Signet.Util.decode_hex!(\"0x59ebeb90bc63057b6515673c3ecf9438e5058bca0f92585014eced636878c9a5\")\n      ]\n    }","ref":"Signet.Receipt.Log.html#deserialize/1-examples"},{"type":"type","title":"Signet.Receipt.Log.t/0","doc":"","ref":"Signet.Receipt.Log.html#t:t/0"},{"type":"module","title":"Signet.Recover","doc":"","ref":"Signet.Recover.html"},{"type":"function","title":"Signet.Recover.find_recid/3","doc":"Finds the given recid which recovers the given signature for the message to the given\nEthereum address. This is a very simple guess-check-revise since there are only four\npossible values, and we only accept two of those.","ref":"Signet.Recover.html#find_recid/3"},{"type":"function","title":"Examples - Signet.Recover.find_recid/3","doc":"iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n  iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n  iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n  iex> Signet.Recover.recover_eth(\"test\", %{sig|recid: recid}) |> Base.encode16()\n  \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Recover.html#find_recid/3-examples"},{"type":"function","title":"Signet.Recover.prefix_eth/1","doc":"Prefixes a message with \"Etheruem Signed Message\" prefix, as per\n[EIP-191](https://eips.ethereum.org/EIPS/eip-191).","ref":"Signet.Recover.html#prefix_eth/1"},{"type":"function","title":"Examples - Signet.Recover.prefix_eth/1","doc":"iex> Signet.Recover.prefix_eth(\"hello\")\n  \"\u0019Ethereum Signed Message:\\n5hello\"","ref":"Signet.Recover.html#prefix_eth/1-examples"},{"type":"function","title":"Signet.Recover.recover_eth/2","doc":"Recovers a signer's Ethereum address from a signed message. The message will\nbe digested by keccak first. Note: the rec_id can be embeded in the signature\nor passed separately.","ref":"Signet.Recover.html#recover_eth/2"},{"type":"function","title":"Examples - Signet.Recover.recover_eth/2","doc":"iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n  iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n  iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n  iex> Signet.Recover.recover_eth(\"test\", %{sig|recid: recid}) |> Base.encode16()\n  \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Recover.html#recover_eth/2-examples"},{"type":"function","title":"Signet.Recover.recover_public_key/2","doc":"Recovers a signer's public key from a signed message. The message will be\ndigested by keccak first. Note: the rec_id can be embeded in the signature\nor passed separately.","ref":"Signet.Recover.html#recover_public_key/2"},{"type":"function","title":"Examples - Signet.Recover.recover_public_key/2","doc":"iex> # Decoded Signature\n  iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n  iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n  iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n  iex> Signet.Recover.recover_public_key(\"test\", %{sig|recid: recid}) |> Base.encode16()\n  \"0480076BFB96955526052B2676DFCA87E0B7869CE85E00C5DBCE29E76B8429D6DBF0F33B1A0095B2A9A4D9EA2A9746B122995A5B5874EE3161138C9D19F072B2D9\"\n\n  iex> # Binary Signature\n  iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n  iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n  iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n  iex> signature = < >\n  iex> Signet.Recover.recover_public_key(\"test\", signature) |> Base.encode16()\n  \"0480076BFB96955526052B2676DFCA87E0B7869CE85E00C5DBCE29E76B8429D6DBF0F33B1A0095B2A9A4D9EA2A9746B122995A5B5874EE3161138C9D19F072B2D9\"\n\n  iex> # EIP-155 Signature\n  iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n  iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n  iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n  iex> recovery_bit = 35 + 5 * 2 + recid\n  iex> signature = < >\n  iex> Signet.Recover.recover_public_key(\"test\", signature) |> Base.encode16()\n  \"0480076BFB96955526052B2676DFCA87E0B7869CE85E00C5DBCE29E76B8429D6DBF0F33B1A0095B2A9A4D9EA2A9746B122995A5B5874EE3161138C9D19F072B2D9\"","ref":"Signet.Recover.html#recover_public_key/2-examples"},{"type":"module","title":"Signet.Signer","doc":"","ref":"Signet.Signer.html"},{"type":"function","title":"Signet.Signer.address/1","doc":"Gets the address for this signer.","ref":"Signet.Signer.html#address/1"},{"type":"function","title":"Examples - Signet.Signer.address/1","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> Signet.Signer.address(signer_proc) |> Base.encode16()\n    \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Signer.html#address/1-examples"},{"type":"function","title":"Signet.Signer.chain_id/1","doc":"Gets the chain id for this signer.","ref":"Signet.Signer.html#chain_id/1"},{"type":"function","title":"Examples - Signet.Signer.chain_id/1","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> Signet.Signer.chain_id(signer_proc)\n    5","ref":"Signet.Signer.html#chain_id/1-examples"},{"type":"function","title":"Signet.Signer.child_spec/1","doc":"Signet.Signer is a GenServer which can sign messages. This module takes an\nmfa (mod, func, args triple) which defines how to actually sign messages.\nFor instance, `Signet.Signer.Curvy` will sign with a public key, or\n`Signet.Signer.CloudKMS` will sign using a GCP Cloud KMS key. In either\ncase, the caller should start the GenServer, and then call:\n`Signet.Signer.sign(MySigner, \"message\")`. This should return back a\nproperly signed message.\n\nNote: we also enforce that a given signer process knows its public key,\nsuch that we can verify signatures recovery bits. That is, since CloudKMS\nand other signing tools don't return a recovery bit, necessary for Ethereum,\nwe test all 4 possible bits to make sure a signature recovers to the correct\nsigner address, but we need to know what that address should be to accomplish\nthis task.\n\nAdditionally, chain_id is used to return EIP-155 compliant signatures.","ref":"Signet.Signer.html#child_spec/1"},{"type":"function","title":"Signet.Signer.handle_call/3","doc":"Handles signing a message. Finds and memoizes address on first call. Address\nis required for finding recovery bit.","ref":"Signet.Signer.html#handle_call/3"},{"type":"function","title":"Signet.Signer.init/1","doc":"Initializes a new Signet.Signer.","ref":"Signet.Signer.html#init/1"},{"type":"function","title":"Signet.Signer.sign/3","doc":"Signs a message using this signing key.","ref":"Signet.Signer.html#sign/3"},{"type":"function","title":"Examples - Signet.Signer.sign/3","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, sig} = Signet.Signer.sign(\"test\", signer_proc)\n    iex> Signet.Recover.recover_eth(\"test\", sig) |> Base.encode16()\n    \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"\n\n    iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, < >} = Signet.Signer.sign(\"test\", signer_proc, chain_id: 0x05f5e0ff)\n    iex> :binary.decode_unsigned(v)\n    0x05f5e0ff * 2 + 35 + 1","ref":"Signet.Signer.html#sign/3-examples"},{"type":"function","title":"Signet.Signer.sign_direct/4","doc":"Directly sign a message, not using a signer process.\n\nThis is mostly used internally, but can be used safely externally as well.","ref":"Signet.Signer.html#sign_direct/4"},{"type":"function","title":"Signet.Signer.start_link/1","doc":"Starts a new Signet.Signer process.","ref":"Signet.Signer.html#start_link/1"},{"type":"module","title":"Signet.Signer.CloudKMS","doc":"Signer to sign messages from a Google Cloud KMS key.","ref":"Signet.Signer.CloudKMS.html"},{"type":"function","title":"Signet.Signer.CloudKMS.get_address/6","doc":"Get the Ethereum address associated with the given KMS key version.","ref":"Signet.Signer.CloudKMS.html#get_address/6"},{"type":"function","title":"Examples - Signet.Signer.CloudKMS.get_address/6","doc":"iex> {:ok, address} = Signet.Signer.CloudKMS.get_address(\"token\", \"project\", \"location\", \"keychain\", \"key\", \"version\")\n    iex> Base.encode16(address)\n    \"DDA641B2A76A4A7C3617815BB13281DD207B74D5\"","ref":"Signet.Signer.CloudKMS.html#get_address/6-examples"},{"type":"function","title":"Signet.Signer.CloudKMS.sign/7","doc":"Signs a message with the given KMS key version, after digesting the message with keccak.","ref":"Signet.Signer.CloudKMS.html#sign/7"},{"type":"function","title":"Examples - Signet.Signer.CloudKMS.sign/7","doc":"iex> {:ok, sig} = Signet.Signer.CloudKMS.sign(\"test\", \"token\", \"project\", \"location\", \"keychain\", \"key\", \"version\")\n    iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"DDA641B2A76A4A7C3617815BB13281DD207B74D5\"))\n    iex> Signet.Recover.recover_eth(\"test\", %{sig|recid: recid}) |> Base.encode16()\n    \"DDA641B2A76A4A7C3617815BB13281DD207B74D5\"","ref":"Signet.Signer.CloudKMS.html#sign/7-examples"},{"type":"module","title":"Signet.Signer.Curvy","doc":"Signer to sign messages using a private key directly. \n\nNote: this should not be used in production systems. Please see `Signet.Signer.CloudKMS`.","ref":"Signet.Signer.Curvy.html"},{"type":"function","title":"Signet.Signer.Curvy.get_address/1","doc":"Get the Ethereum address associated with the given private key.","ref":"Signet.Signer.Curvy.html#get_address/1"},{"type":"function","title":"Examples - Signet.Signer.Curvy.get_address/1","doc":"iex> priv_key = \"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\" |> Base.decode16!(case: :mixed)\n    iex> {:ok, address} = Signet.Signer.Curvy.get_address(priv_key)\n    iex> Base.encode16(address)\n    \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Signer.Curvy.html#get_address/1-examples"},{"type":"function","title":"Signet.Signer.Curvy.sign/2","doc":"Signs the given message using the private key, after digesting the message with keccak.","ref":"Signet.Signer.Curvy.html#sign/2"},{"type":"function","title":"Examples - Signet.Signer.Curvy.sign/2","doc":"iex> priv_key = Base.decode16!(\"800509fa3e80882ad0be77c27505bdc91380f800d51ed80897d22f9fcc75f4bf\", case: :mixed)\n    iex> {:ok, sig} = Signet.Signer.Curvy.sign(\"test\", priv_key)\n    iex> {:ok, recid} = Signet.Recover.find_recid(\"test\", sig, Base.decode16!(\"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"))\n    iex> Signet.Recover.recover_eth(\"test\", %{sig|recid: recid}) |> Base.encode16()\n    \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Signer.Curvy.html#sign/2-examples"},{"type":"module","title":"Signet.Trace","doc":"Represents an Ethereum transaction trace, which contains information\nabout the call graph of an executed transaction.\n\nSee `Signet.RPC.trace_transaction` for getting traces from\nan Ethereum JSON-RPC host.\n\nSee also:\n  * Alcemy docs: https://docs.alchemy.com/reference/trace-transaction\n  * Infura docs: https://docs.infura.io/networks/ethereum/json-rpc-methods/trace-methods/trace_transaction\n  * Infura trace object: https://docs.infura.io/networks/ethereum/json-rpc-methods/trace-methods/#trace","ref":"Signet.Trace.html"},{"type":"function","title":"Signet.Trace.deserialize/1","doc":"Deserializes a single trace result from `trace_transction`. Note: a JSON-RPC response will\nreturn an array of such traces.","ref":"Signet.Trace.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Trace.deserialize/1","doc":"iex> %{\n    ...>   \"action\" => %{\n    ...>     \"callType\" => \"call\",\n    ...>     \"from\" => \"0x83806d539d4ea1c140489a06660319c9a303f874\",\n    ...>     \"gas\" => \"0x1a1f8\",\n    ...>     \"input\" => \"0x\",\n    ...>     \"to\" => \"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\",\n    ...>     \"value\" => \"0x7a16c911b4d00000\"\n    ...>   },\n    ...>   \"blockHash\" => \"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\",\n    ...>   \"blockNumber\" => 3068185,\n    ...>   \"result\" => %{\n    ...>     \"gasUsed\" => \"0x2982\",\n    ...>     \"output\" => \"0x\"\n    ...>   },\n    ...>   \"subtraces\" => 2,\n    ...>   \"traceAddress\" => [\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"],\n    ...>   \"transactionHash\" => \"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\",\n    ...>   \"transactionPosition\" => 2,\n    ...>   \"type\" => \"call\"\n    ...> }\n    ...> |> Signet.Trace.deserialize()\n    %Signet.Trace{\n      action: %Signet.Trace.Action{\n        call_type: \"call\",\n        from: Signet.Util.decode_hex!(\"0x83806d539d4ea1c140489a06660319c9a303f874\"),\n        gas: 0x01a1f8,\n        input: <<>>,\n        to: Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"),\n        value: 0x7a16c911b4d00000,\n      },\n      block_hash: Signet.Util.decode_hex!(\"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\"),\n      block_number: 3068185,\n      gas_used: 0x2982,\n      output: <<>>,\n      subtraces: 2,\n      trace_address: [Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\")],\n      transaction_hash: Signet.Util.decode_hex!(\"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\"),\n      transaction_position: 2,\n      type: \"call\"\n    }","ref":"Signet.Trace.html#deserialize/1-examples"},{"type":"function","title":"Signet.Trace.deserialize_many/1","doc":"Deserializes an array of trace results from `trace_transction`.","ref":"Signet.Trace.html#deserialize_many/1"},{"type":"function","title":"Examples - Signet.Trace.deserialize_many/1","doc":"iex> [%{\n    ...>   \"action\" => %{\n    ...>     \"callType\" => \"call\",\n    ...>     \"from\" => \"0x83806d539d4ea1c140489a06660319c9a303f874\",\n    ...>     \"gas\" => \"0x1a1f8\",\n    ...>     \"input\" => \"0x\",\n    ...>     \"to\" => \"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\",\n    ...>     \"value\" => \"0x7a16c911b4d00000\"\n    ...>   },\n    ...>   \"blockHash\" => \"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\",\n    ...>   \"blockNumber\" => 3068185,\n    ...>   \"result\" => %{\n    ...>     \"gasUsed\" => \"0x2982\",\n    ...>     \"output\" => \"0x\"\n    ...>   },\n    ...>   \"subtraces\" => 2,\n    ...>   \"traceAddress\" => [\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"],\n    ...>   \"transactionHash\" => \"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\",\n    ...>   \"transactionPosition\" => 2,\n    ...>   \"type\" => \"call\"\n    ...> }]\n    ...> |> Signet.Trace.deserialize_many()\n    [\n      %Signet.Trace{\n        action: %Signet.Trace.Action{\n          call_type: \"call\",\n          from: Signet.Util.decode_hex!(\"0x83806d539d4ea1c140489a06660319c9a303f874\"),\n          gas: 0x01a1f8,\n          input: <<>>,\n          to: Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"),\n          value: 0x7a16c911b4d00000,\n        },\n        block_hash: Signet.Util.decode_hex!(\"0x7eb25504e4c202cf3d62fd585d3e238f592c780cca82dacb2ed3cb5b38883add\"),\n        block_number: 3068185,\n        gas_used: 0x2982,\n        output: <<>>,\n        subtraces: 2,\n        trace_address: [Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\")],\n        transaction_hash: Signet.Util.decode_hex!(\"0x17104ac9d3312d8c136b7f44d4b8b47852618065ebfa534bd2d3b5ef218ca1f3\"),\n        transaction_position: 2,\n        type: \"call\"\n      }\n    ]","ref":"Signet.Trace.html#deserialize_many/1-examples"},{"type":"type","title":"Signet.Trace.t/0","doc":"","ref":"Signet.Trace.html#t:t/0"},{"type":"module","title":"Signet.Trace.Action","doc":"","ref":"Signet.Trace.Action.html"},{"type":"function","title":"Signet.Trace.Action.deserialize/1","doc":"Deserializes a trace sub-action into a struct.","ref":"Signet.Trace.Action.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Trace.Action.deserialize/1","doc":"iex> %{\n    ...>   \"callType\" => \"call\",\n    ...>   \"from\" => \"0x83806d539d4ea1c140489a06660319c9a303f874\",\n    ...>   \"gas\" => \"0x1a1f8\",\n    ...>   \"input\" => \"0x\",\n    ...>   \"to\" => \"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\",\n    ...>   \"value\" => \"0x7a16c911b4d00000\"\n    ...> }\n    ...> |> Signet.Trace.Action.deserialize()\n    %Signet.Trace.Action{\n      call_type: \"call\",\n      from: Signet.Util.decode_hex!(\"0x83806d539d4ea1c140489a06660319c9a303f874\"),\n      gas: 0x01a1f8,\n      input: <<>>,\n      to: Signet.Util.decode_hex!(\"0x1c39ba39e4735cb65978d4db400ddd70a72dc750\"),\n      value: 0x7a16c911b4d00000,\n    }","ref":"Signet.Trace.Action.html#deserialize/1-examples"},{"type":"type","title":"Signet.Trace.Action.t/0","doc":"","ref":"Signet.Trace.Action.html#t:t/0"},{"type":"module","title":"Signet.Transaction","doc":"A module to help build, sign and encode Ethereum transactions.","ref":"Signet.Transaction.html"},{"type":"function","title":"Signet.Transaction.build_signed_trx/7","doc":"Builds and signs a transaction, to be ready to be passed to JSON-RPC.\n\nOptionally takes a callback to modify the transaction before it is signed.","ref":"Signet.Transaction.html#build_signed_trx/7"},{"type":"function","title":"Examples - Signet.Transaction.build_signed_trx/7","doc":"iex> signer_proc = Signet.Test.Signer.start_signer()\n    iex> {:ok, signed_trx} = Signet.Transaction.build_signed_trx(<<1::160>>, 5, {\"baz(uint,address)\", [50, :binary.decode_unsigned(<<1::160>>)]}, {50, :gwei}, 100_000, 0, signer: signer_proc, chain_id: :goerli)\n    iex> {:ok, signer} = Signet.Transaction.V1.recover_signer(signed_trx, 5)\n    iex> Base.encode16(signer)\n    \"63CC7C25E0CDB121ABB0FE477A6B9901889F99A7\"","ref":"Signet.Transaction.html#build_signed_trx/7-examples"},{"type":"function","title":"Signet.Transaction.build_trx/7","doc":"Builds a v1-style call to a given contract","ref":"Signet.Transaction.html#build_trx/7"},{"type":"function","title":"Examples - Signet.Transaction.build_trx/7","doc":"iex> Signet.Transaction.build_trx(<<1::160>>, 5, {\"baz(uint,address)\", [50, :binary.decode_unsigned(<<1::160>>)]}, {50, :gwei}, 100_000, 0, 5)\n    %Signet.Transaction.V1{\n      nonce: 5,\n      gas_price: 50000000000,\n      gas_limit: 100000,\n      to: <<1::160>>,\n      value: 0,\n      data: Base.decode16!(\"A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001\"),\n      v: 5,\n      r: 0,\n      s: 0\n    }\n\n    iex> call_data = Base.decode16!(\"A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001\")\n    ...> Signet.Transaction.build_trx(<<1::160>>, 5, call_data, {50, :gwei}, 100_000, 0, 5)\n    %Signet.Transaction.V1{\n      nonce: 5,\n      gas_price: 50000000000,\n      gas_limit: 100000,\n      to: <<1::160>>,\n      value: 0,\n      data: Base.decode16!(\"A291ADD600000000000000000000000000000000000000000000000000000000000000320000000000000000000000000000000000000000000000000000000000000001\"),\n      v: 5,\n      r: 0,\n      s: 0\n    }","ref":"Signet.Transaction.html#build_trx/7-examples"},{"type":"module","title":"Signet.Transaction.V1","doc":"Represents a V1 or \"Legacy\" (that is, pre-EIP-1559) transaction.","ref":"Signet.Transaction.V1.html"},{"type":"function","title":"Signet.Transaction.V1.add_signature/2","doc":"Adds a signature to a transaction. This overwrites the `[chain_id, 0, 0]` fields, as per EIP-155.","ref":"Signet.Transaction.V1.html#add_signature/2"},{"type":"function","title":"Examples - Signet.Transaction.V1.add_signature/2","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.add_signature(<<1::256, 2::256, 3::8>>)\n    %Signet.Transaction.V1{\n      nonce: 1,\n      gas_price: 100000000000,\n      gas_limit: 100000,\n      to: <<1::160>>,\n      value: 2,\n      data: <<1, 2, 3>>,\n      v: 3,\n      r: <<1::256>>,\n      s: <<2::256>>\n    }","ref":"Signet.Transaction.V1.html#add_signature/2-examples"},{"type":"function","title":"Signet.Transaction.V1.decode/1","doc":"Decode an RLP-encoded transaction.","ref":"Signet.Transaction.V1.html#decode/1"},{"type":"function","title":"Examples - Signet.Transaction.V1.decode/1","doc":"iex> \"E80185174876E800830186A094000000000000000000000000000000000000000102830102032A8080\"\n    ...> |> Base.decode16!()\n    ...> |> Signet.Transaction.V1.decode()\n    {:ok, %Signet.Transaction.V1{\n      nonce: 1,\n      gas_price: 100000000000,\n      gas_limit: 100000,\n      to: <<1::160>>,\n      value: 2,\n      data: <<1, 2, 3>>,\n      v: 42,\n      r: 0,\n      s: 0\n    }}","ref":"Signet.Transaction.V1.html#decode/1-examples"},{"type":"function","title":"Signet.Transaction.V1.encode/1","doc":"Build an RLP-encoded transaction. Note: transactions can be encoded before they are signed, which\nuses `[chain_id, 0, 0]` in the signature fields, otherwise those fields are `[v, r, s]`.","ref":"Signet.Transaction.V1.html#encode/1"},{"type":"function","title":"Examples - Signet.Transaction.V1.encode/1","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.encode()\n    ...> |> Base.encode16()\n    \"E80185174876E800830186A094000000000000000000000000000000000000000102830102032A8080\"","ref":"Signet.Transaction.V1.html#encode/1-examples"},{"type":"function","title":"Signet.Transaction.V1.get_signature/1","doc":"Recovers a signature from a transaction, if it's been signed. Otherwise returns an error.","ref":"Signet.Transaction.V1.html#get_signature/1"},{"type":"function","title":"Examples - Signet.Transaction.V1.get_signature/1","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.add_signature(<<1::256, 2::256, 3::8>>)\n    ...> |> Signet.Transaction.V1.get_signature()\n    {:ok, <<1::256, 2::256, 3::8>>}\n\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.add_signature(<<1::256, 2::256, 0x05f5e0ff::32>>)\n    ...> |> Signet.Transaction.V1.get_signature()\n    {:ok, <<1::256, 2::256, 0x05f5e0ff::32>>}\n\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.get_signature()\n    {:error, \"transaction missing signature\"}","ref":"Signet.Transaction.V1.html#get_signature/1-examples"},{"type":"function","title":"Signet.Transaction.V1.new/7","doc":"Constructs a new V1 (Legacy) Ethereum transaction.","ref":"Signet.Transaction.V1.html#new/7"},{"type":"function","title":"Examples - Signet.Transaction.V1.new/7","doc":"iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    %Signet.Transaction.V1{\n      nonce: 1,\n      gas_price: 100000000000,\n      gas_limit: 100000,\n      to: <<1::160>>,\n      value: 2,\n      data: <<1, 2, 3>>,\n      v: 42,\n      r: 0,\n      s: 0\n    }","ref":"Signet.Transaction.V1.html#new/7-examples"},{"type":"function","title":"Signet.Transaction.V1.recover_signer/2","doc":"Recovers the signer from a given transaction, if it's been signed.","ref":"Signet.Transaction.V1.html#recover_signer/2"},{"type":"function","title":"Examples - Signet.Transaction.V1.recover_signer/2","doc":"iex> {:ok, address} =\n    ...> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.add_signature(<<1::256, 2::256, 3::8>>)\n    ...> |> Signet.Transaction.V1.recover_signer(:kovan)\n    ...> Base.encode16(address)\n    \"47643AC1194D7E8C6D04DD631D456137028BBC1F\"\n\n    iex> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>, :kovan)\n    ...> |> Signet.Transaction.V1.recover_signer(:kovan)\n    {:error, \"transaction missing signature\"}","ref":"Signet.Transaction.V1.html#recover_signer/2-examples"},{"type":"module","title":"Signet.Typed","doc":"Module to build EIP-712 typed data, which can then be signed or recovered from.","ref":"Signet.Typed.html"},{"type":"function","title":"Signet.Typed.deserialize/1","doc":"Deserializes a Typed value from JSON or a map into a struct.","ref":"Signet.Typed.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Typed.deserialize/1","doc":"iex> %{\n    ...>   \"domain\" => %{\n    ...>     \"name\" => \"Ether Mail\",\n    ...>     \"version\" => \"1\",\n    ...>     \"chainId\" => 1,\n    ...>     \"verifyingContract\" => \"0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC\"\n    ...>   },\n    ...>   \"types\" => %{\n    ...>     \"Person\" => [\n    ...>       %{\n    ...>         \"name\" => \"name\",\n    ...>         \"type\" => \"string\"\n    ...>       },\n    ...>       %{\n    ...>         \"name\" => \"wallet\",\n    ...>         \"type\" => \"address\"\n    ...>       },\n    ...>     ],\n    ...>     \"Mail\" => [\n    ...>       %{\n    ...>         \"name\" => \"from\",\n    ...>         \"type\" => \"Person\"\n    ...>       },\n    ...>       %{\n    ...>         \"name\" => \"to\",\n    ...>         \"type\" => \"Person\"\n    ...>       },\n    ...>       %{\n    ...>         \"name\" => \"contents\",\n    ...>         \"type\" => \"string\"\n    ...>       },\n    ...>     ]\n    ...>   },\n    ...>   \"value\" => %{\n    ...>     \"from\" => %{ \"name\" => \"Cow\", \"wallet\" => \"0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826\" },\n    ...>     \"to\" => %{ \"name\" => \"Bob\", \"wallet\" => \"0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB\" },\n    ...>     \"contents\" => \"Hello, Bob!\"\n    ...>   }\n    ...> }\n    ...> |> Signet.Typed.deserialize()\n    %Signet.Typed{\n      domain: %Signet.Typed.Domain{\n        chain_id: 1,\n        name: \"Ether Mail\",\n        verifying_contract: \"\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\",\n        version: \"1\"\n      },\n      types: %{\n        \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n        \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n      },\n      value: %{\n        \"contents\" => \"Hello, Bob!\",\n        \"from\" => %{\n          \"name\" => \"Cow\",\n          \"wallet\" => <<205, 42, 61, 159, 147, 142, 19, 205, 148, 126, 192, 90, 188, 127, 231, 52, 223, 141, 216, 38>>\n        },\n        \"to\" => %{\n          \"name\" => \"Bob\",\n          \"wallet\" =>\n            <<187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187>>\n        }\n      }\n    }","ref":"Signet.Typed.html#deserialize/1-examples"},{"type":"function","title":"Signet.Typed.domain_seperator/1","doc":"Builds a domain struct for a given type, per the EIP-712 spec.","ref":"Signet.Typed.html#domain_seperator/1"},{"type":"function","title":"Examples - Signet.Typed.domain_seperator/1","doc":"iex> %Signet.Typed{\n    ...>   domain: %Signet.Typed.Domain{\n    ...>     chain_id: 1,\n    ...>     name: \"Ether Mail\",\n    ...>     verifying_contract: Signet.Util.decode_hex!(\"0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC\"),\n    ...>     version: \"1\"\n    ...>   },\n    ...>   types: %{\n    ...>     \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    ...>     \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n    ...>   },\n    ...>   value: %{\n    ...>     \"contents\" => \"Hello, Bob!\",\n    ...>     \"from\" => %{\n    ...>       \"name\" => \"Cow\",\n    ...>       \"wallet\" => Signet.Util.decode_hex!(\"0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826\")\n    ...>     },\n    ...>     \"to\" => %{\n    ...>       \"name\" => \"Bob\",\n    ...>       \"wallet\" => Signet.Util.decode_hex!(\"0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB\")\n    ...>     }\n    ...>   }\n    ...> }\n    ...> |> Signet.Typed.domain_seperator()\n    ...> |> Signet.Util.encode_hex()\n    \"0xF2CEE375FA42B42143804025FC449DEAFD50CC031CA257E0B194A650A912090F\"","ref":"Signet.Typed.html#domain_seperator/1-examples"},{"type":"function","title":"Signet.Typed.encode/1","doc":"Encodes a given typed value such that it can be signed or recovered.","ref":"Signet.Typed.html#encode/1"},{"type":"function","title":"Examples - Signet.Typed.encode/1","doc":"iex> %Signet.Typed{\n    ...>   domain: %Signet.Typed.Domain{\n    ...>     chain_id: 1,\n    ...>     name: \"Ether Mail\",\n    ...>     verifying_contract: Signet.Util.decode_hex!(\"0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC\"),\n    ...>     version: \"1\"\n    ...>   },\n    ...>   types: %{\n    ...>     \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    ...>     \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n    ...>   },\n    ...>   value: %{\n    ...>     \"contents\" => \"Hello, Bob!\",\n    ...>     \"from\" => %{\n    ...>       \"name\" => \"Cow\",\n    ...>       \"wallet\" => Signet.Util.decode_hex!(\"0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826\")\n    ...>     },\n    ...>     \"to\" => %{\n    ...>       \"name\" => \"Bob\",\n    ...>       \"wallet\" => Signet.Util.decode_hex!(\"0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB\")\n    ...>     }\n    ...>   }\n    ...> }\n    ...> |> Signet.Typed.encode()\n    ...> |> Signet.Util.encode_hex()\n    \"0x1901F2CEE375FA42B42143804025FC449DEAFD50CC031CA257E0B194A650A912090FC52C0EE5D84264471806290A3F2C4CECFC5490626BF912D01F240D7A274B371E\"","ref":"Signet.Typed.html#encode/1-examples"},{"type":"function","title":"Signet.Typed.encode_type/2","doc":"Encodes the struct type per EIP-712. For this, we basically build an ABI-style value\nlike `Mail(Person from,Person to,string contents)`, but then to that we need to append\nany other types we've seen, like:\n\n`Mail(Person from,Person to,string contents)Person(string name,address wallet)`.\n\nThis is a tail-call optimized implementation to build the types then track and append types that need to be added.","ref":"Signet.Typed.html#encode_type/2"},{"type":"function","title":"Examples - Signet.Typed.encode_type/2","doc":"iex> Signet.Typed.encode_type(\"Mail\", %{\n    ...>   \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    ...>   \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n    ...> })\n    \"Mail(Person from,Person to,string contents)Person(string name,address wallet)\"","ref":"Signet.Typed.html#encode_type/2-examples"},{"type":"function","title":"Signet.Typed.hash_struct/3","doc":"Hashes a struct value, per the EIP-712 spec.","ref":"Signet.Typed.html#hash_struct/3"},{"type":"function","title":"Examples - Signet.Typed.hash_struct/3","doc":"iex> types = %{\n    ...>   \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    ...>   \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n    ...> }\n    ...> value = %{\n    ...>   \"contents\" => \"Hello, Bob!\",\n    ...>   \"from\" => %{\n    ...>     \"name\" => \"Cow\",\n    ...>     \"wallet\" => Signet.Util.decode_hex!(\"0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826\")\n    ...>   },\n    ...>   \"to\" => %{\n    ...>     \"name\" => \"Bob\",\n    ...>     \"wallet\" => Signet.Util.decode_hex!(\"0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB\")\n    ...>   }\n    ...> }\n    ...> Signet.Typed.hash_struct(\"Mail\", value, types)\n    ...> |> Signet.Util.encode_hex()\n    \"0xC52C0EE5D84264471806290A3F2C4CECFC5490626BF912D01F240D7A274B371E\"","ref":"Signet.Typed.html#hash_struct/3-examples"},{"type":"function","title":"Signet.Typed.serialize/1","doc":"Serializes a Typed value, such that it can be passed to JSON or JavaScript.","ref":"Signet.Typed.html#serialize/1"},{"type":"function","title":"Examples - Signet.Typed.serialize/1","doc":"iex> %Signet.Typed{\n    ...>   domain: %Signet.Typed.Domain{\n    ...>     chain_id: 1,\n    ...>     name: \"Ether Mail\",\n    ...>     verifying_contract: \"\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\\xCC\",\n    ...>     version: \"1\"\n    ...>   },\n    ...>   types: %{\n    ...>     \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    ...>     \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n    ...>   },\n    ...>   value: %{\n    ...>     \"contents\" => \"Hello, Bob!\",\n    ...>     \"from\" => %{\n    ...>       \"name\" => \"Cow\",\n    ...>       \"wallet\" => <<205, 42, 61, 159, 147, 142, 19, 205, 148, 126, 192, 90, 188, 127, 231, 52, 223, 141, 216, 38>>\n    ...>     },\n    ...>     \"to\" => %{\n    ...>       \"name\" => \"Bob\",\n    ...>       \"wallet\" =>\n    ...>         <<187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187>>\n    ...>     }\n    ...>   }\n    ...> }\n    ...> |> Signet.Typed.serialize()\n    %{\n      \"domain\" => %{\n        \"name\" => \"Ether Mail\",\n        \"version\" => \"1\",\n        \"chainId\" => 1,\n        \"verifyingContract\" => \"0xCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC\"\n      },\n      \"types\" => %{\n        \"Person\" => [\n          %{\n            \"name\" => \"name\",\n            \"type\" => \"string\"\n          },\n          %{\n            \"name\" => \"wallet\",\n            \"type\" => \"address\"\n          },\n        ],\n        \"Mail\" => [\n          %{\n            \"name\" => \"from\",\n            \"type\" => \"Person\"\n          },\n          %{\n            \"name\" => \"to\",\n            \"type\" => \"Person\"\n          },\n          %{\n            \"name\" => \"contents\",\n            \"type\" => \"string\"\n          },\n        ]\n      },\n      \"value\" => %{\n        \"from\" => %{ \"name\" => \"Cow\", \"wallet\" => \"0xCD2A3D9F938E13CD947EC05ABC7FE734DF8DD826\" },\n        \"to\" => %{ \"name\" => \"Bob\", \"wallet\" => \"0xBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB\" },\n        \"contents\" => \"Hello, Bob!\"\n      }\n    }","ref":"Signet.Typed.html#serialize/1-examples"},{"type":"type","title":"Signet.Typed.t/0","doc":"","ref":"Signet.Typed.html#t:t/0"},{"type":"type","title":"Signet.Typed.type_map/0","doc":"","ref":"Signet.Typed.html#t:type_map/0"},{"type":"type","title":"Signet.Typed.value_map/0","doc":"","ref":"Signet.Typed.html#t:value_map/0"},{"type":"module","title":"Signet.Typed.Domain","doc":"","ref":"Signet.Typed.Domain.html"},{"type":"function","title":"Signet.Typed.Domain.deserialize/1","doc":"Deserializes a domain from JSON or JavaScript encoding to a struct.","ref":"Signet.Typed.Domain.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Typed.Domain.deserialize/1","doc":"iex> %{\n    ...>   \"name\" => \"Ether Mail\",\n    ...>   \"version\" => \"1\",\n    ...>   \"chainId\" => 1,\n    ...>   \"verifyingContract\" => \"0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC\",\n    ...> }\n    ...> |> Signet.Typed.Domain.deserialize()\n    %Signet.Typed.Domain{\n      name: \"Ether Mail\",\n      version: \"1\",\n      chain_id: 1,\n      verifying_contract: <<204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204>>\n    }","ref":"Signet.Typed.Domain.html#deserialize/1-examples"},{"type":"function","title":"Signet.Typed.Domain.domain_type/0","doc":"","ref":"Signet.Typed.Domain.html#domain_type/0"},{"type":"function","title":"Signet.Typed.Domain.serialize/1","doc":"Serializes a domain, such that it can be JSON-encoded or passed to JavaScript.","ref":"Signet.Typed.Domain.html#serialize/1"},{"type":"function","title":"Examples - Signet.Typed.Domain.serialize/1","doc":"iex> %Signet.Typed.Domain{\n    ...>   name: \"Ether Mail\",\n    ...>   version: \"1\",\n    ...>   chain_id: 1,\n    ...>   verifying_contract: <<204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204>>\n    ...> }\n    ...> |> Signet.Typed.Domain.serialize()\n    %{\n      \"name\" => \"Ether Mail\",\n      \"version\" => \"1\",\n      \"chainId\" => 1,\n      \"verifyingContract\" => \"0xCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC\",\n    }","ref":"Signet.Typed.Domain.html#serialize/1-examples"},{"type":"function","title":"Signet.Typed.Domain.serialize_keys/1","doc":"Serializes a domain's keys to be JSON-compatible. This is so that it can be used\nas a value for `hashStruct`, per the EIP-712 spec to build a domain specifier.","ref":"Signet.Typed.Domain.html#serialize_keys/1"},{"type":"function","title":"Examples - Signet.Typed.Domain.serialize_keys/1","doc":"iex> %Signet.Typed.Domain{\n    ...>   name: \"Ether Mail\",\n    ...>   version: \"1\",\n    ...>   chain_id: 1,\n    ...>   verifying_contract: <<204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204>>\n    ...> }\n    ...> |> Signet.Typed.Domain.serialize_keys()\n    %{\n      \"name\" => \"Ether Mail\",\n      \"version\" => \"1\",\n      \"chainId\" => 1,\n      \"verifyingContract\" => <<204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204, 204>>\n    }","ref":"Signet.Typed.Domain.html#serialize_keys/1-examples"},{"type":"type","title":"Signet.Typed.Domain.t/0","doc":"","ref":"Signet.Typed.Domain.html#t:t/0"},{"type":"module","title":"Signet.Typed.Type","doc":"","ref":"Signet.Typed.Type.html"},{"type":"function","title":"Signet.Typed.Type.deserialize/1","doc":"Deserializes a Type from JSON or a map into a struct.","ref":"Signet.Typed.Type.html#deserialize/1"},{"type":"function","title":"Examples - Signet.Typed.Type.deserialize/1","doc":"iex> [%{\n    ...>   \"name\" => \"from\",\n    ...>   \"type\" => \"Person\",\n    ...> }, %{\n    ...>   \"name\" => \"to\",\n    ...>   \"type\" => \"Person\",\n    ...> }, %{\n    ...>   \"name\" => \"contents\",\n    ...>   \"type\" => \"string\",\n    ...> }]\n    ...> |> Signet.Typed.Type.deserialize()\n    %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]}","ref":"Signet.Typed.Type.html#deserialize/1-examples"},{"type":"function","title":"Signet.Typed.Type.deserialize_type/1","doc":"Deserializes a primitive or custom type. We differentiate\ncustom types by not being a primitive type.","ref":"Signet.Typed.Type.html#deserialize_type/1"},{"type":"function","title":"Examples - Signet.Typed.Type.deserialize_type/1","doc":"iex> Signet.Typed.Type.deserialize_type(\"address\")\n    :address\n\n    iex> Signet.Typed.Type.deserialize_type(\"bytes\")\n    :bytes\n\n    iex> Signet.Typed.Type.deserialize_type(\"uint256\")\n    {:uint, 256}\n\n    iex> Signet.Typed.Type.deserialize_type(\"bytes32\")\n    {:bytes, 32}\n\n    iex> Signet.Typed.Type.deserialize_type(\"Person\")\n    \"Person\"","ref":"Signet.Typed.Type.html#deserialize_type/1-examples"},{"type":"function","title":"Signet.Typed.Type.deserialize_value!/2","doc":"Deserializes a value of a given type for being stored in this struct.","ref":"Signet.Typed.Type.html#deserialize_value!/2"},{"type":"function","title":"Examples - Signet.Typed.Type.deserialize_value!/2","doc":"iex> Signet.Typed.Type.deserialize_value!(\"0x0000000000000000000000000000000000000001\", :address)\n    <<1::160>>\n\n    iex> Signet.Typed.Type.deserialize_value!(55, {:uint, 256})\n    55\n\n    iex> Signet.Typed.Type.deserialize_value!(\"0x00000000000000000000000000000000000000000000000000000000000000CC\", {:bytes, 32})\n    <<0xCC::256>>\n\n    iex> Signet.Typed.Type.deserialize_value!(\"0xCC\", {:bytes, 32})\n    <<0xCC::256>>\n\n    iex> Signet.Typed.Type.deserialize_value!(\"Cow\", :string)\n    \"Cow\"\n\n    iex> Signet.Typed.Type.deserialize_value!(\"0xCCDD\", :bytes)\n    <<0xCC, 0xDD>>","ref":"Signet.Typed.Type.html#deserialize_value!/2-examples"},{"type":"function","title":"Signet.Typed.Type.encode_data_value/2","doc":"Encodes a value for `encodeData`, as per the EIP-712 spec. Specifically, raw values are\nexpanded to 32-bytes, and dynamic types are hashed.","ref":"Signet.Typed.Type.html#encode_data_value/2"},{"type":"function","title":"Examples - Signet.Typed.Type.encode_data_value/2","doc":"iex> Signet.Typed.Type.encode_data_value(<<1::160>>, :address)\n    <<1::256>>\n\n    iex> Signet.Typed.Type.encode_data_value(55, {:uint, 256})\n    <<0::248, 55>>\n\n    iex> Signet.Typed.Type.encode_data_value(<<0xCC>>, {:bytes, 32})\n    <<0::248, 0xCC>>\n\n    iex> Signet.Typed.Type.encode_data_value(<<0xCC, 0xDD>>, :bytes)\n    <<144, 20, 184, 80, 112, 54, 41, 211, 15, 92, 140, 108, 134, 166, 173, 152, 26, 185, 49, 153, 151, 73, 6, 41, 215, 218, 55, 232, 202, 233, 133, 161>>\n\n    iex> Signet.Typed.Type.encode_data_value(\"Cow\", :string)\n    <<140, 29, 43, 213, 52, 131, 148, 118, 23, 25, 218, 17, 236, 103, 238, 218, 233, 80, 45, 19, 126, 137, 64, 254, 232, 236, 214, 246, 65, 238, 22, 72>>","ref":"Signet.Typed.Type.html#encode_data_value/2-examples"},{"type":"function","title":"Signet.Typed.Type.serialize/1","doc":"Serializes a Type, such that it can be used with JSON or JavaScript.","ref":"Signet.Typed.Type.html#serialize/1"},{"type":"function","title":"Examples - Signet.Typed.Type.serialize/1","doc":"iex> %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]}\n    ...> |> Signet.Typed.Type.serialize()\n    [%{\n      \"name\" => \"from\",\n      \"type\" => \"Person\",\n    }, %{\n      \"name\" => \"to\",\n      \"type\" => \"Person\",\n    }, %{\n      \"name\" => \"contents\",\n      \"type\" => \"string\",\n    }]","ref":"Signet.Typed.Type.html#serialize/1-examples"},{"type":"function","title":"Signet.Typed.Type.serialize_type/1","doc":"Serializes a primitive or custom type.","ref":"Signet.Typed.Type.html#serialize_type/1"},{"type":"function","title":"Examples - Signet.Typed.Type.serialize_type/1","doc":"iex> Signet.Typed.Type.serialize_type(:address)\n    \"address\"\n\n    iex> Signet.Typed.Type.serialize_type({:uint, 256})\n    \"uint256\"\n\n    iex> Signet.Typed.Type.serialize_type({:bytes, 32})\n    \"bytes32\"\n\n    iex> Signet.Typed.Type.serialize_type(:bytes)\n    \"bytes\"\n\n    iex> Signet.Typed.Type.serialize_type(\"Person\")\n    \"Person\"","ref":"Signet.Typed.Type.html#serialize_type/1-examples"},{"type":"function","title":"Signet.Typed.Type.serialize_value/2","doc":"Serializes a value of a given type to pass to JSON or JavaScript.","ref":"Signet.Typed.Type.html#serialize_value/2"},{"type":"function","title":"Examples - Signet.Typed.Type.serialize_value/2","doc":"iex> Signet.Typed.Type.serialize_value(<<1::160>>, :address)\n    \"0x0000000000000000000000000000000000000001\"\n\n    iex> Signet.Typed.Type.serialize_value(55, {:uint, 256})\n    55\n\n    iex> Signet.Typed.Type.serialize_value(<<0xCC::256>>, {:bytes, 32})\n    \"0x00000000000000000000000000000000000000000000000000000000000000CC\"\n\n    iex> Signet.Typed.Type.serialize_value(<<0xCC>>, {:bytes, 32})\n    \"0x00000000000000000000000000000000000000000000000000000000000000CC\"\n\n    iex> Signet.Typed.Type.serialize_value(\"Cow\", :string)\n    \"Cow\"\n\n    iex> Signet.Typed.Type.serialize_value(<<0xCC, 0xDD>>, :bytes)\n    \"0xCCDD\"","ref":"Signet.Typed.Type.html#serialize_value/2-examples"},{"type":"type","title":"Signet.Typed.Type.field_type/0","doc":"","ref":"Signet.Typed.Type.html#t:field_type/0"},{"type":"type","title":"Signet.Typed.Type.primitive/0","doc":"","ref":"Signet.Typed.Type.html#t:primitive/0"},{"type":"type","title":"Signet.Typed.Type.t/0","doc":"","ref":"Signet.Typed.Type.html#t:t/0"},{"type":"type","title":"Signet.Typed.Type.type_list/0","doc":"","ref":"Signet.Typed.Type.html#t:type_list/0"},{"type":"module","title":"Signet.Util","doc":"","ref":"Signet.Util.html"},{"type":"function","title":"Signet.Util.checksum_address/1","doc":"Checksums an Ethereum address per [EIP-55](https://github.com/ethereum/EIPs/blob/master/EIPS/eip-55.md),\nthe result is a string-encoded version of the address.","ref":"Signet.Util.html#checksum_address/1"},{"type":"function","title":"Examples - Signet.Util.checksum_address/1","doc":"iex> Signet.Util.checksum_address(\"0x5aaeb6053f3e94c9b9a09f33669435e7ef1beaed\")\n    \"0x5aAeb6053F3E94C9b9A09f33669435E7Ef1BeAed\"\n\n    iex> Signet.Util.checksum_address(\"0xFB6916095CA1DF60BB79CE92CE3EA74C37C5D359\")\n    \"0xfB6916095ca1df60bB79Ce92cE3Ea74c37c5d359\"\n\n    iex> Signet.Util.checksum_address(\"0xdbf03b407c01e7cd3cbea99509d93f8dddc8c6fb\")\n    \"0xdbF03B407c01E7cD3CBea99509d93f8DDDC8C6FB\"\n\n    iex> Signet.Util.checksum_address(\"0xd1220a0cf47c7b9be7a2e6ba89f429762e7b9adb\")\n    \"0xD1220A0cf47c7B9Be7A2E6BA89F429762e7b9aDb\"","ref":"Signet.Util.html#checksum_address/1-examples"},{"type":"function","title":"Signet.Util.decode_address!/1","doc":"Decodes hex if the size is exactly one 20-byte address, otherwise raises.","ref":"Signet.Util.html#decode_address!/1"},{"type":"function","title":"Examples - Signet.Util.decode_address!/1","doc":"iex> Signet.Util.decode_address!(\"0x00112233445566778899aabbccddeeff00112233\")\n  <<0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff,0x00,0x11,0x22,0x33>>\n\n  iex> Signet.Util.decode_address!(\"0x1122\")\n  ** (RuntimeError) mismatch byte size. expected 20, got: 2","ref":"Signet.Util.html#decode_address!/1-examples"},{"type":"function","title":"Signet.Util.decode_hex/1","doc":"Decodes a hex string, specifically requiring that the string begins\nwith `0x` and allows mixed-case typing.","ref":"Signet.Util.html#decode_hex/1"},{"type":"function","title":"Examples - Signet.Util.decode_hex/1","doc":"iex> Signet.Util.decode_hex(\"0x1122\")\n  {:ok, <<0x11, 0x22>>}\n\n  iex> Signet.Util.decode_hex(\"0x1\")\n  {:ok, <<0x1>>}\n\n  iex> Signet.Util.decode_hex(\"0xGG\")\n  :error","ref":"Signet.Util.html#decode_hex/1-examples"},{"type":"function","title":"Signet.Util.decode_hex!/1","doc":"Decodes a hex string, specifically requiring that the string begins\nwith `0x` and allows mixed-case typing.\n\nSimilar to `decode_hex/1`, but raises on error","ref":"Signet.Util.html#decode_hex!/1"},{"type":"function","title":"Examples - Signet.Util.decode_hex!/1","doc":"iex> Signet.Util.decode_hex!(\"0x1122\")\n  <<0x11, 0x22>>\n\n  iex> Signet.Util.decode_hex!(\"0x1\")\n  <<0x1>>\n\n  iex> Signet.Util.decode_hex!(\"0xGG\")\n  ** (RuntimeError) invalid hex","ref":"Signet.Util.html#decode_hex!/1-examples"},{"type":"function","title":"Signet.Util.decode_hex_input!/1","doc":"Decodes hex, allowing it to either by \"0x...\" or <<1::160>>.\n\nNote: a hex-printed string, in this case, must start with 0x,\n      otherwise it will be interpreted as its ASCII values.","ref":"Signet.Util.html#decode_hex_input!/1"},{"type":"function","title":"Examples - Signet.Util.decode_hex_input!/1","doc":"iex> Signet.Util.decode_hex_input!(\"0x55\")\n    <<0x55>>\n\n    iex> Signet.Util.decode_hex_input!(<<0x55>>)\n    <<0x55>>","ref":"Signet.Util.html#decode_hex_input!/1-examples"},{"type":"function","title":"Signet.Util.decode_hex_number!/1","doc":"Decodes hex to an integer.","ref":"Signet.Util.html#decode_hex_number!/1"},{"type":"function","title":"Examples - Signet.Util.decode_hex_number!/1","doc":"iex> Signet.Util.decode_hex_number!(\"0x11223344\")\n  0x11223344","ref":"Signet.Util.html#decode_hex_number!/1-examples"},{"type":"function","title":"Signet.Util.decode_sized_hex!/2","doc":"Decodes hex but requires the result be a given set of bytes, or\notherwise raises.","ref":"Signet.Util.html#decode_sized_hex!/2"},{"type":"function","title":"Examples - Signet.Util.decode_sized_hex!/2","doc":"iex> Signet.Util.decode_sized_hex!(\"0x1122\", 2)\n  <<0x11, 0x22>>\n\n  iex> Signet.Util.decode_sized_hex!(\"0x1122\", 3)\n  ** (RuntimeError) mismatch byte size. expected 3, got: 2\n\n  iex> Signet.Util.decode_sized_hex!(\"0xGG\", 3)\n  ** (RuntimeError) invalid hex","ref":"Signet.Util.html#decode_sized_hex!/2-examples"},{"type":"function","title":"Signet.Util.decode_word!/1","doc":"Decodes hex if the size is exactly one 32-byte word, otherwise raises.","ref":"Signet.Util.html#decode_word!/1"},{"type":"function","title":"Examples - Signet.Util.decode_word!/1","doc":"iex> Signet.Util.decode_word!(\"0x00112233445566778899aabbccddeeff00112233445566778899aabbccddeeff\")\n  <<0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff>>\n\n  iex> Signet.Util.decode_word!(\"0x1122\")\n  ** (RuntimeError) mismatch byte size. expected 32, got: 2","ref":"Signet.Util.html#decode_word!/1-examples"},{"type":"function","title":"Signet.Util.encode_bytes/2","doc":"Encodes a number as a binary representation of a certain number of\nbytes.","ref":"Signet.Util.html#encode_bytes/2"},{"type":"function","title":"Examples - Signet.Util.encode_bytes/2","doc":"iex> Signet.Util.encode_bytes(257, 4)\n  <<0, 0, 1, 1>>\n\n  iex> Signet.Util.encode_bytes(nil, 4)\n  nil","ref":"Signet.Util.html#encode_bytes/2-examples"},{"type":"function","title":"Signet.Util.encode_hex/2","doc":"Encodes a hex string, adding a `0x` prefix.\n\nNote: if `short` is set, then any leading zeros will be stripped.","ref":"Signet.Util.html#encode_hex/2"},{"type":"function","title":"Examples - Signet.Util.encode_hex/2","doc":"iex> Signet.Util.encode_hex(<<0x11, 0x22>>)\n  \"0x1122\"\n\n  iex> Signet.Util.encode_hex(<<0xc>>)\n  \"0x0C\"\n\n  iex> Signet.Util.encode_hex(<<0xc>>, true)\n  \"0xC\"\n\n  iex> Signet.Util.encode_hex(<<0x0>>, true)\n  \"0x0\"","ref":"Signet.Util.html#encode_hex/2-examples"},{"type":"function","title":"Signet.Util.get_eth_address/1","doc":"Returns an Ethereum address from a given DER-encoded public key.","ref":"Signet.Util.html#get_eth_address/1"},{"type":"function","title":"Examples - Signet.Util.get_eth_address/1","doc":"iex> public_key = Signet.Util.decode_hex!(\"0x0422\")\n  iex> Signet.Util.get_eth_address(public_key) |> Signet.Util.encode_hex()\n  \"0x759F1AFDC24ABA433A3E18B683F8C04A6EAA69F0\"","ref":"Signet.Util.html#get_eth_address/1-examples"},{"type":"function","title":"Signet.Util.keccak/1","doc":"","ref":"Signet.Util.html#keccak/1"},{"type":"function","title":"Signet.Util.nibbles/1","doc":"Returns the nibbles of a binary as a list.","ref":"Signet.Util.html#nibbles/1"},{"type":"function","title":"Examples - Signet.Util.nibbles/1","doc":"iex> Signet.Util.nibbles(<<0xF5,0xE6,0xD0>>)\n    [0xF, 0x5, 0xE, 0x6, 0xD, 0x0]","ref":"Signet.Util.html#nibbles/1-examples"},{"type":"function","title":"Signet.Util.pad/2","doc":"Pads a binary to a given length","ref":"Signet.Util.html#pad/2"},{"type":"function","title":"Examples - Signet.Util.pad/2","doc":"iex> Signet.Util.pad(<<1, 2>>, 2)\n  <<1, 2>>\n\n  iex> Signet.Util.pad(<<1, 2>>, 4)\n  <<0, 0, 1, 2>>\n\n  iex> Signet.Util.pad(<<1, 2>>, 1)\n  ** (FunctionClauseError) no function clause matching in Signet.Util.pad/2","ref":"Signet.Util.html#pad/2-examples"},{"type":"function","title":"Signet.Util.parse_chain_id/1","doc":"Parses a chain id, which can be given as an integer or an atom of a known network.","ref":"Signet.Util.html#parse_chain_id/1"},{"type":"function","title":"Examples - Signet.Util.parse_chain_id/1","doc":"iex> Signet.Util.parse_chain_id(5)\n    5\n\n    iex> Signet.Util.parse_chain_id(:goerli)\n    5","ref":"Signet.Util.html#parse_chain_id/1-examples"},{"type":"function","title":"Signet.Util.to_wei/1","doc":"Converts a number to wei, possibly from gwei, etc.","ref":"Signet.Util.html#to_wei/1"},{"type":"function","title":"Examples - Signet.Util.to_wei/1","doc":"iex> Signet.Util.to_wei(100)\n    100\n\n    iex> Signet.Util.to_wei({100, :gwei})\n    100000000000","ref":"Signet.Util.html#to_wei/1-examples"},{"type":"module","title":"Signet.Util.RecoveryBit","doc":"There are a number of ways to look at recovery bits. Either:\n\n* `:base`: In the range `{0,1}`, which are the outputs of a signer library\n* `:ethereum`: In the range `{27,28}`, as defined in the yellow paper\n* `:eip155`: In the range `{35+chain_id*2,35+chain_id*2+1}`, as defined in EIP-155\n\nThis module provides tools between switching through these choices.","ref":"Signet.Util.RecoveryBit.html"},{"type":"function","title":"Signet.Util.RecoveryBit.normalize/2","doc":"Normalizes a binary-encoded signature to the given requested type,\ni.e. `:base`, `:ethereum`, or `:eip155`.","ref":"Signet.Util.RecoveryBit.html#normalize/2"},{"type":"function","title":"Examples - Signet.Util.RecoveryBit.normalize/2","doc":"iex> Signet.Util.RecoveryBit.normalize(28, :eip155)\n    46\n\n    iex> Signet.Util.RecoveryBit.normalize(1, :ethereum)\n    28\n\n    iex> Signet.Util.RecoveryBit.normalize(45, :base)\n    0","ref":"Signet.Util.RecoveryBit.html#normalize/2-examples"},{"type":"function","title":"Signet.Util.RecoveryBit.normalize_signature/2","doc":"Normalizes a binary-encoded signature to the given requested type,\ni.e. `:base`, `:ethereum`, or `:eip155`.","ref":"Signet.Util.RecoveryBit.html#normalize_signature/2"},{"type":"function","title":"Examples - Signet.Util.RecoveryBit.normalize_signature/2","doc":"iex> Signet.Util.RecoveryBit.normalize_signature(<<1::256, 2::256, 28>>, :eip155)\n    <<1::256, 2::256, 46>>\n\n    iex> Signet.Util.RecoveryBit.normalize_signature(<<1::256, 2::256, 1>>, :ethereum)\n    <<1::256, 2::256, 28>>\n\n    iex> Signet.Util.RecoveryBit.normalize_signature(<<1::256, 2::256, 45>>, :base)\n    <<1::256, 2::256, 0>>","ref":"Signet.Util.RecoveryBit.html#normalize_signature/2-examples"},{"type":"function","title":"Signet.Util.RecoveryBit.recover_base/1","doc":"Normalizes a recovery bit to be either 0 or 1.","ref":"Signet.Util.RecoveryBit.html#recover_base/1"},{"type":"function","title":"Examples - Signet.Util.RecoveryBit.recover_base/1","doc":"iex> Signet.Util.RecoveryBit.recover_base(0)\n    0\n\n    iex> Signet.Util.RecoveryBit.recover_base(1)\n    1\n\n    iex> Signet.Util.RecoveryBit.recover_base(27)\n    0\n\n    iex> Signet.Util.RecoveryBit.recover_base(28)\n    1\n\n    iex> Signet.Util.RecoveryBit.recover_base(45)\n    0\n\n    iex> Signet.Util.RecoveryBit.recover_base(46)\n    1\n\n    iex> Signet.Util.RecoveryBit.recover_base(47)\n    ** (RuntimeError) Invalid EIP-155 Signature: recovery_bit=47, chain_id=5\n\n    iex> Signet.Util.RecoveryBit.recover_base(2)\n    ** (FunctionClauseError) no function clause matching in Signet.Util.RecoveryBit.recover_base/1","ref":"Signet.Util.RecoveryBit.html#recover_base/1-examples"},{"type":"type","title":"Signet.Util.RecoveryBit.rec_type/0","doc":"","ref":"Signet.Util.RecoveryBit.html#t:rec_type/0"},{"type":"extras","title":"Signet","doc":"# Signet\n[![Build Status](https://github.com/hayesgm/signet/workflows/Signet%20Tests/badge.svg)](https://github.com/hayesgm/signet/actions?query=workflow%3A%22Signet+Tests%22) [![Hex Version](https://img.shields.io/hexpm/v/signet.svg)](https://hex.pm/packages/signet/) [![Documentation](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/signet/) [![Downloads](https://img.shields.io/hexpm/dt/signet.svg)](https://hex.pm/packages/signet) [![Last Updated](https://img.shields.io/github/last-commit/hayesgm/signet.svg)](https://github.com/hayesgm/signet/commits/main)\n\n\n \n\n----\nSignet is a lightweight Ethereum RPC client for Elixir. The goal is to make it easy to interact with Ethereum in Elixir. As an example:\n\n```elixir\n{:ok, trx_id} =\n  Signet.RPC.execute_trx(\n    \"0x123...\",\n    {\"transfer(uint)\", [50]},\n    gas_price: {50, :gwei},\n    value: 0\n  )\n```\n\nThe above code will use a signer you set-up (see below) to send a build, sign and transmit a transaction to Infura. Signet handles determining your nonce and estimating the gas cost, and, by default, fails if the transaction were to revert.\n\nSignet has a number of other features, including:\n\n  * Signing and verifying Ethereum signatures (including [EIP-191](https://eips.ethereum.org/EIPS/eip-191))\n  * Signing and verifying [EIP-712 typed data](https://eips.ethereum.org/EIPS/eip-712)\n  * Signing via [Curvy](https://github.com/libitx/curvy) or [Google KMS](https://cloud.google.com/kms/docs/apis).\n    * Note: Curvy signatures should be avoided in production.\n  * Filters through active processes","ref":"readme.html"},{"type":"extras","title":"Installation - Signet","doc":"Signet can be installed by adding `signet` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:signet, \"~> 0.2.0\"}\n  ]\nend\n```\n\nDocumentation can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Getting Started - Signet","doc":"#","ref":"readme.html#getting-started"},{"type":"extras","title":"Signers - Signet","doc":"First, you'll need to set-up a signer, which will be used to sign transactions or other messages. Signers are GenServers, and uou can set-up several signers, and you will specify a name of a signer (or pid) at the point of actually using the signer. Currently there are two supported signers: raw keys or Google KMS.\n\n##","ref":"readme.html#signers"},{"type":"extras","title":"Raw Key - Signet","doc":"** Note: This uses an experimental Elixir signing library, Curvy, and is considered unsafe for production. **\n\nYou can specify a signer key by configuring:\n\n** runtime.exs **\n\n```elixir\nconfig :signet, :signer,\n  [{MySigner, {:priv_key, System.get_env(\"MY_PRIVATE_KEY\")}}]\n```\n\nThen use `MySigner` when asked for a signer when using Signet.\n\nYou can also specify a default signer, which will be used by default so you do not need to specify the signer in your calls:\n\n```elixir\nconfig :signet, :signer, default: {:priv_key, System.get_env(\"MY_PRIVATE_KEY\")}\n```\n\n##","ref":"readme.html#raw-key"},{"type":"extras","title":"Google KMS - Signet","doc":"You can set-up Google KMS by configuring:\n\n```elixir\nconfig :signet, :signer, [\n  {MySigner, {:cloud_kms, GCPCredentials, \"projects/{project}/locations/{location}/keyRings/{keyring}/cryptoKeys/{keyid}\", \"1\"}}]\n```\n\nThis will use your given key from the URL, version \"1\", for signing.\n\n`GCPCredentials` should be a `Goth` process set-up with proper credentials to access Google Cloud KMS.\n\n##","ref":"readme.html#google-kms"},{"type":"extras","title":"Custom Signers - Signet","doc":"You can also specify custom signers by specifying an mfa that implements the required behavior:\n\n```elixir\nconfig :signet, :signers, %{\n  MySigner: {:mfa, Signet.Signer.Curvy, :sign, [<<1::256>>]}\n}\n```\n\nFeel free to add pull requests with new signing methods.\n\nYou can also spawn your own process by adding to your start-up application:\n\n```elixir\nchildren = [\n  # ...\n  {Signet.Signer, mfa: {...}, chain_id: chain_id, name: MySigner}\n]\n```\n\nNote: if you do not name your signer, it will be named `Signet.Signer.Default` and will be used to sign all transactions unless otherwise specified.\n\n#","ref":"readme.html#custom-signers"},{"type":"extras","title":"Signing - Signet","doc":"Now that you have a signer, you can sign data, for instance:\n\n```elixir\n{:ok, sig} = Signet.Signer.sign(\"test\", MySigner)\n```\n\nAnd then you can recover it via:\n\n```elixir\nsigner_address = Signet.Recover.recover_eth(\"test\", sig)\n```\n\nYou can also sign EIP-712 typed data:\n\n```elixir\n%Signet.Typed{\n  domain: %Signet.Typed.Domain{\n    chain_id: 1,\n    name: \"Ether Mail\",\n    verifying_contract: Signet.Util.decode_hex!(\"0xCcCCccccCCCCcCCCCCCcCcCccCcCCCcCcccccccC\"),\n    version: \"1\"\n  },\n  types: %{\n    \"Mail\" => %Signet.Typed.Type{fields: [{\"from\", \"Person\"}, {\"to\", \"Person\"}, {\"contents\", :string}]},\n    \"Person\" => %Signet.Typed.Type{fields: [{\"name\", :string}, {\"wallet\", :address}]}\n  },\n  value: %{\n    \"contents\" => \"Hello, Bob!\",\n    \"from\" => %{\n      \"name\" => \"Cow\",\n      \"wallet\" => Signet.Util.decode_hex!(\"0xCD2a3d9F938E13CD947Ec05AbC7FE734Df8DD826\")\n    },\n    \"to\" => %{\n      \"name\" => \"Bob\",\n      \"wallet\" => Signet.Util.decode_hex!(\"0xbBbBBBBbbBBBbbbBbbBbbbbBBbBbbbbBbBbbBBbB\")\n    }\n  }\n}\n|> Signet.Typed.encode()\n|> Signet.Signer.sign()\n```\n\n#","ref":"readme.html#signing"},{"type":"extras","title":"RPC - Signet","doc":"Signet includes an RPC library to talk to Ethereum nodes, such as Infura. First, specify an Ethereum node address, e.g.\n\n** config.exs **\n```elixir\nconfig :signet,\n  ethereum_node: \"https://goerli.infura.io\"\n  chain_id: :goerli\n```\n\nThen, you can run any Ethereum JSON-RPC command, e.g.:\n\n```elixir\nSignet.RPC.send_rpc(\"net_version\", [])\n{:ok, \"3\"}\n```\n\nYou can build an Ethereum (pre-EIP-1559) transaction, e.g.:\n\n```elixir\ntransaction = Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<1::160>>, {2, :wei}, <<1, 2, 3>>)\n```\n\nAnd you can get the results from calling that transaction, via:\n\n```elixir\n{:ok, <<0x0c>>} = Signet.RPC.call_trx(transaction)\n```\n\nAnd if you're happy, you can send the trx:\n\n```elixir\n{:ok, trx_id} = Signet.RPC.send_trx(transaction)\n```\n\nYou can also pass in known Solidity errors, to have them decoded for you, e.g.:\n\n```elixir\n> errors = [\"Cool(uint256,string)\"]\n> Signet.Transaction.V1.new(1, {100, :gwei}, 100_000, <<11::160>>, {2, :wei}, <<1, 2, 3>>)\n> |> Signet.RPC.call_trx(errors: errors)\n{:error, \"error 3: execution reverted (Cool(uint256,string)[1, \\\"cat\\\"])\"}\n```\n\nFinally, `execute_trx` is similar to sending transactions with Web3, which will pull a nonce and estimate gas, before submitting the transaction to the Ethereum node:\n\n```elixir\n{:ok, trx_id} = Signet.RPC.execute_trx(<<1::160>>, {\"baz(uint,address)\", [50, <<1::160>> |> :binary.decode_unsigned]}, priority_fee: {2, :gwei}, gas_limit: 100_000, value: 0, nonce: 10)\n```\n\nNote: due to our ABI encoder, addresses should be passed in as `unsigned`s, not binaries.\n\nYou can pull a transaction receipt via:\n\n```elixir\n{:ok, receipt} = Signet.RPC.get_trx_receipt(trx_id)\n```\n\nYou can pull a transaction traces via:\n\n```elixir\n{:ok, trace} = Signet.RPC.trace_transaction(trx_id)\n```\n\n#","ref":"readme.html#rpc"},{"type":"extras","title":"Filtering - Signet","doc":"The library also has a built-in system to use JSON-RPC filters (i.e. via `eth_newFilter`). In your application.ex (or any other supervisor), start a new filter:\n\n```\nchildren = [\n  # ...\n                   # Filter name     # Address    # Topics\n  {Signet.Filter, [MyTransferFilter, <<1::160>>, [<<2::256>>]]}\n]\n```\n\nThen, in your code, any process can register to hear events from the filter via:\n\n```elixir\nSignet.Filter.listen(MyTransferFilter)\n```\n\nOnce registered, events will be passed in via Elixir messages `{:event, event}` for decoded events and `{:log, log}` for plain logs. For example:\n\n```elixir\ndefmodule MyGenServer do\n  use GenServer\n\n  # ...\n  def init(_) do\n    Signet.Filter.listen(MyTransferFilter)\n  end\n\n  def handle_info({:event, event, log}, state) do\n    IO.inspect(event, label: \"New Event\")\n    {:noreply, state}\n  end\n\n  def handle_info({:log, log}, state) do\n    IO.inspect(log, label: \"New Log\")\n    {:noreply, state}\n  end\nend\n```\n\nCurrently, only ERC-20 transfer events as decoded, e.g. as:\n\n```elixir\n{:event, {\"Transfer\", %{\"from\" => <<1::160>>, \"to\" => <<2::160>>, \"amount\" => 100}}, %Signet.Filter.Log{}}\n```\n\nNote: filters may expire if not refreshed every so often. The filter code does not attempt to reach back in time if a filter is expired- that is up to your code.","ref":"readme.html#filtering"},{"type":"extras","title":"Keys - Signet","doc":"You can create Ethereum keys using Signet. These libraries are built on top of erlang's [crypto](https://www.erlang.org/doc/man/crypto.html) library, so they should be production safe, but you should be careful none-the-less when generating private keys in your app.\n\n```elixir\n> {address, priv_key} = Signet.Keys.generate_keypair()\n> Signet.Util.encode_hex(address)\n\"0x3586B0916AC3C042A2B7E4A73841977941A69C4F\"\n\n> Signet.Util.encode_hex(priv_key)\n\"0x2EADD3966648553096523C38BB464E7DFDDD30293D02909FA2200FF571A90E85\"\n```","ref":"readme.html#keys"},{"type":"extras","title":"Contributing - Signet","doc":"Create a PR to contribute to Signet. All contributors agree to accept the license specified in this repository for all contributions to this project. See [LICENSE.md](/LICENSE.md).\n\nFeel free to create Feature Requests in the issues.\n\nNote: The author generated the Signet logo with DALL•E, OpenAI's text-to-image generation model. The image was further modified by the author.","ref":"readme.html#contributing"}],"content_type":"text/markdown"}